﻿using SmsService.Interfaces;
using SmsService.Services;

namespace SmsService.Factories
{
    public class SmsFactories
    {
        /// <summary>
        /// Фабрика SmsHub.
        /// </summary>
        /// <param name="token"></param>
        /// <returns></returns>
        public ISmsService SmsHub(string token)
        {
            ISmsService smsService = new SmsHub(token);
            return smsService;
        }

        /// <summary>
        /// Фабрика SmsActivate.
        /// </summary>
        /// <param name="token"></param>
        /// <returns></returns>
        public ISmsService SmsActivate(string token)
        {
            ISmsService smsService = new SmsActivate(token);
            return smsService;
        }

        /// <summary>
        /// Фабрика SmsActivateRent.
        /// </summary>
        /// <param name="token"></param>
        /// <param name="rentTime"></param>
        /// <returns></returns>
        public ISmsService SmsActivateRent(string token, Rent rentTime)
        {
            ISmsService smsService = new SmsActivateRent(token, rentTime);
            return smsService;
        }

        public ISmsService Simsms(string token)
        {
            ISmsService smsService = new Simsms(token);
            return smsService;
        }
    }
}
