﻿using Global.ZennoLab.Json.Linq;
using SmsService.Interfaces;
using ZennoLab.CommandCenter;

namespace SmsService.Services
{
    public class Simsms : ISmsService
    {
        public string Id { get; protected set; }
        public string Name { get; protected set; }
        public string Code { get; protected set; }
        public string Number { get; protected set; }
        public string Responce { get; protected set; }

        public string Proxy { get; protected set; }
        public string Token { get; protected set; }
        public string ApiHandler { get; protected set; }

        public Simsms(string token)
        {
            Name = "Simsms";
            Token = token;
            ApiHandler = "https://simsms.org/priemnik.php?apikey=" + Token;
        }

        public decimal GetBalance()
        {
            var reqUrl = ApiHandler + "&metod=get_balance" +
                "&service=opt4";

            Responce = ZennoPoster.HttpGet(reqUrl, proxy: Proxy);

            var balance = JObject.Parse(Responce)
                .SelectToken("balance")
                .ToString();
            var result = decimal.Parse(balance.Replace(".", ","));
            return result;
        }

        public bool GetCode(int attempts = 3, int pause_Sec = 30)
        {
            throw new System.NotImplementedException();
        }

        public bool GetNumber(string service, string country, string smsOperator = "")
        {
            throw new System.NotImplementedException();
        }

        /// <summary>
        /// Установить прокси.
        /// </summary>
        /// <param name="proxy">proxy: login:pass@ip:port</param>
        public void SetProxy(string proxy)
        {
            Proxy = proxy;
        }

        public void SmsCancel()
        {
            throw new System.NotImplementedException();
        }

        public void SmsOk()
        {
            throw new System.NotImplementedException();
        }
    }
}
