﻿using SmsService.Factories;
using SmsService.Interfaces;
using System;

namespace SmsService
{
    public class SmsInit
    {
        [ThreadStatic] public static ISmsService Service;

        private readonly SmsFactories _factory;

        public SmsInit()
        {
            _factory = new SmsFactories();
        }

        /// <summary>
        /// Инициализировать SmsHub.
        /// </summary>
        /// <param name="proxy"></param>
        /// <returns></returns>
        public ISmsService SmsHub(string token, string proxy)
        {
            Service = _factory.SmsHub(token);
            Service.SetProxy(proxy);

            return Service;
        }

        /// <summary>
        /// Инициализировать SmsActivate.
        /// </summary>
        /// <returns></returns>
        public ISmsService SmsActivate(string token)
        {
            Service = _factory.SmsActivate(token);

            return Service;
        }

        /// <summary>
        /// Инициализировать SmsActivateRent.
        /// </summary>
        /// <param name="rentTime"></param>
        /// <returns></returns>
        public ISmsService SmsActivateRent(string token, Rent rentTime)
        {
            Service = _factory.SmsActivateRent(token, rentTime);

            return Service;
        }

        public ISmsService Simsms(string token, string proxy)
        {
            Service = _factory.Simsms(token);
            Service.SetProxy(proxy);

            return Service;
        }
    }
}
